Subject: Announcing term117
From: "Bill C. Riemers" <[email-masked]>
Date: Sat, 4 Jun 1994 18:55:18 GMT
Newsgroups: comp.os.linux.announce

Announcing the release of term117

WHAT IS IT?

  "term" is a program written by Michael O'Reilly which simmulates many
  SLIP like features through an ordinary user's account.  At this time
  Michael is quite busy and doesn't have time to work on "term" or to 
  answer your questions, so please direct questions to me: 

  [email-masked] (Bill C. Riemers)

  I'm currently running my mail handler on this account as well so if you
  don't want an automatic reply, use a subject starting with the word "private".

  For SCO unix specific questions, try asking:

    [email-masked] (Tim Pusher)

WHERE IS IT?

  "term117" will be available at:

  bohr.physics.purdue.edu:/pub/bcr/term/term117.tar.gz
  sunsite.unc.edu:/pub/Linux/apps/comm/?????/term117.tar.gz  

     (Appearently there are mirror problems on sunsite, that have kept the
      finial destination from being decided yet.)

  Feel free to mirror these directories on other sites.

WHERE CAN I FIND TERM BINARIES AND APPLICATION SOURCES?

  You can find lots of stuff for old style term support at:
    sunsite.unc.edu:/pub/Linux/apps/comm/termstuff/
    sunsite.unc.edu:/pub/Linux/apps/comm/term/term/extra/

  Since the new-style term support, does require patches to source codes
  in many cases, I have been putting new style binaries at:

    bohr.physics.purdue.edu:/pub/bcr/term/extra

  - If I need to hack the source code for "shared" support, I'll also upload
  the patch.

  - If you are using shared mode, you may need to set "TERMSHARE" to your
  shared directory for these to work.

CALL FOR ALPHA TESTERS:

  For those intested in ALPHA testing, I'm keeping the ALPHA versions on
  bohr.physics.purdue.edu.  For the most part, I expect ALPHA testers to
  know something about C.  So even if you can't find a problem at least
  you can provide a meaningfull bug support.  Often times, bugs are only
  present under OS's I don't have access to, so you need to be prepared
  to try tests for me and to play around abit.

WHAT'S NEW WITH "term117"?

  "term117" is mainly a bugfix release of "term116", meaning there aren't
  too many new features.  The only real exciting new things are C_GETHOSTNAME,
  C_GETPEERNAME, C_GETSOCKNAME.  At this point the new porting procedure
  only uses the C_GETHOSTNAME.

  There are several new patches people sent me that didn't make it into this
  release, mainly because I wanted to get the bug fixes out right away, so
  expect "xntp" and "tdownload" in term118.  If you are really impatient
  for these new features, you can try using the ALPHA releases, but don't
  be surprised if you have problems!

  --  IMPORTANT --  The default shared directory has been changed to: 

  	/usr/local/lib/term

  because many people keep /usr/lib as read-only.

WHAT'S NEW WITH "term116"?

  "term116" was essientially "term115" with the term115.share.v7 patch
   applied.  This means that term116 had the following new features:

    - The ability to safely share a connection.  (If you are allowing
      multiple users use your same term connection without this patch,
      your only security protection is thier lack of understanding or
      modivation to hack term clients.)  

    - A new simplified porting procedure that allows you to compile
      programs like "telnet", "rlogin", "ftp", ... simply by changing
      two lines in the Makefile.  (Note: The bug with "ftp"'s put command
      has been fixed with term117.)  This does not imply that the 
      program will be safe for sharing.  (In particulary you still need
      to patch "ftp" and "ncftp" before running in shared mode.)

    - Added BSDI support

   Unfortunately, term116 also had most of the same bugs as term115.

CHANGE LOG:

1.16 - 1.17 ([email-masked])
 - More changes to the TERMIOS stuff
 - Added socket address passing with C_ACCEPT.
 - Added patches suggested by [email-masked] (Bruce) for AIX
 - Added the patch by Chris Metcalf to:
  o  support for both "universe" models under HCX/UX; this allowed me to
     bag the "universe ucb" I put in the Makefile, and take out the 
     restrictive comment in config.h under hcx.  Term seems to compile
     fine under both versions.  I ifdef'ed out the initial "Remote: term"
     message under hcx since this makes it hang when running under "test".

  o  Portability to NeXT 2.1, which doesn't have S_IXUSR and S_IXGRP.

  o  reworked support for the hideous terminal_new() crock (all my fault).
     The whole static struct termios thing is a tremendous lose.
     Different OSes disagree about field placement (e.g. c_line, and
     the VFOO fields of c_cc) and name of symbolic constants to use
     (e.g. values for c_line).  The right thing to do is to pull in
     the oldterm as the default, then update the fields you actually
     know about to good values.  I also finally did the right thing
     and added the equivalent support for the BSD model.  Note that I
     also change ECHOCTL to be 0 if it's undefined, since some other
     random hex value is likely to correspond to some unwanted tty mode.
     (The #ifdef Next stuff disappeared, but I don't think "Next" is
     defined on the NeXT anyway, just "NeXT".)

  o  I added an ultrix target in the Makefile (just like OSF/1 or SGI).
     I also changed SHAREDIR to be under /usr/local, along with the rest
     of the default directories; although people will probably change
     these to match their local structure anyway, it ought to be consistent.

  o  A bunch of changes to make the -Wall compile cleanly under Linux.
     These include %d vs. %ld to match argument size, variable
     initialization where gcc doesn't realize the variable can't really
     be used uninitialized, adding parentheses around && and ||, removing
     variables and function calls that aren't used, and adding includes
     (either explicitly or by forcing I_IOCTL) to prototype functions.
     It turns out you don't want to include <sys/ioctl.h> as well as
     the termios stuff on SunOS 4.x, so I explicitly checked for that.

  o  Changes to allow term to compile with the HCX/UX C compiler.  
     Constructs like "=-" and "=+" used to be synonomous with "-="
     and "+=", and the HCX/UX compiler warns about them and then does
     the wrong thing.  So I added whitespace around the "=" to fix it.
     (I also did two other minor portability mods:  I changed "index"
     to "strchr" in termnet.c for consistency, and replaced "strdup"
     with "malloc/strcpy" to avoid requiring it to be in the library.)

  - Added Derek Atkins patch for C_GETHOSTNAME, C_GETSOCKNAME, and
    C_GETPEERNAME
  - wrote translation functions str_to_sockaddr(), str_to_hostent(),
    hostent_to_str(), sockaddr_to_str() and modified routines to use
    these.
  - Modified term_gethostname() to use C_GETHOSTNAME
  - Modified term_connect() not to expect special address #'s for 
    remote hosts. 
  - Added term_gethostbyaddr()
  - Corrected term_accept() to do C_DUMB...  
  - Raised the defualt MAX_CLIENTS to 64

1.15 - 1.16 ([email-masked])
 - added the NO_PTYEXEC option so trsh now works without the '-s' option
   when connecting to TitanOS
 - Modified Makefile to include titan.
 - Modified Makefile to have the rule "installshare" and other minor
   changes needed for shared support.
 - Modified main.c and client.c to handle shared mode
 - Modified anyplace I saw an exec or a open to swap userid (if possable).
 - Modified clients for setuid and setgid security.
 - term_gethostbyname, term_connect, and term_rcmd added to client.c
 - modified client.h to reflect these changes.
 - fixed trshell.c to default to "rlogin localhost".
 - Added additional functions term_bind, term_accept, term_close, term_shutdown
 - Added the command C_BINDS to allow AF_INET sockets to connect to a unix
   domain socket.
 - Modified C_BINDN to work for non-zero port #'s.
 - Moved the new networking stuff into termnet.h and termnet.c
 - Renamed the global "debug" to "term_debug" to aviod conflicts.
 - Fixed? N_FTP problem.
 - Added BSDI support.

--
Mail submissions for comp.os.linux.announce to: [email-masked]
Be sure to include Keywords: and a short description of your software.